???File Path
==========
***...\Controllers\AirticketController.cs




???Check the points
==================
1) Set Error code no -> airticket_CONTROLLER.CS#??? 



            // ??? Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using Newtonsoft.Json;
            using System.Linq;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Helpers;
            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Travel;
            using TAAS.Src.Travel;
        


            // ??? The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new DbService();
            AirFareCode insAirFareCode = new AirFareCode();
        


            [HttpGet("GetAirFareCodeInitializeData")]
            public IActionResult GetAirFareCodeInitializeData()
            {
                try
                {
                    // &&& Get Data from Header
                    long linLoginUserId = Convert.ToInt64(Request.Headers["linLoginUserId"]);
                    //string strLoginUserName = Request.Headers["strLoginUserName"];
                    string strSysModuleName = Request.Headers["strSysModuleName"];
                    //var dtmCurrentDateTime = DateTime.Now;

                    // *** Authentication Checking
                    if (linLoginUserId == 0) {
                        throw (new TaasAuthenticationException(this.insGlobalFunctions.FnGetExceptionResponseString("Login User Authentication Failed.", "AIRTICKET_CONTROLLER.CS#001")));
                    }

                    // *** VIEW - User Permission Checking
                    string strAction = "VIEW";
                    NpgsqlParameter[] lstSqlParameter = {
                        new NpgsqlParameter("linLoginUserId", NpgsqlDbType.Bigint) { Value = linLoginUserId, DataTypeName = "linLoginUserId"},
                        new NpgsqlParameter("vhrSysModuleName", NpgsqlDbType.Varchar, 250) { Value = strSysModuleName, DataTypeName = "vhrSysModuleName"},
                        new NpgsqlParameter("vhrAction", NpgsqlDbType.Varchar, 50) { Value = strAction, DataTypeName = "vhrAction"},
                    };
                    DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_check_user_permission(:linLoginUserId, :vhrSysModuleName, :vhrAction)",  lstSqlParameter);
                    if (objDataSet != null && Convert.ToInt16(objDataSet.Tables[0].Rows[0]["sin_sql_check_status"]) == -1)
                    {
                        throw (new TaasUserPermissionException(this.insGlobalFunctions.FnGetExceptionResponseString("You have no Permission to AirFareCode VIEW.", "AIRTICKET_CONTROLLER.CS#002")));
                    }

                    MdlResAirFareCodeInit mdlResAirFareCodeInit = new MdlResAirFareCodeInit();

                    // ??? Check and Rename or Remove If unwanted codes
			AirFareType insAirFareType = new AirFareType();
			mdlResAirFareCodeInit.lstMdlAirFareTypeBaseIntId = insAirFareType.FnGetAllAirFareTypeKeyIntValue();
			AirlineMaster insAirlineMaster = new AirlineMaster();
			mdlResAirFareCodeInit.lstMdlAirlineMasterBaseIntId = insAirlineMaster.FnGetAllAirlineMasterKeyIntValue();

                    // AirFareCode List
                    mdlResAirFareCodeInit.lstMdlAirFareCode = this.insAirFareCode.FnGetAllAirFareCodeWithActionUser();

                    return Ok(mdlResAirFareCodeInit);
                }
                
                catch (TaasAuthenticationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "AUTHENTICATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "Authentication Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasUserPermissionException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "USER_PERMISSION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode User Permission Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasModelValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "MODEL_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Model Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasLogicalException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "LOGICAL_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Logical Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasNoDataException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "NO_DATA_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode No Data Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Taas Error.";

                    return Ok(mdlResponse);
                }
                catch (Exception ex)
                {
                    MdlResponse mdlResponse = new MdlResponse();

                    mdlResponse.sinStatus = -1;
                    mdlResponse.strStatusCode = "ERROR";
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strErrorCode = "AIRTICKET_CONTROLLER.CS#001";
                    mdlResponse.strMessage = "AirFareCode Error.";
                    mdlResponse.strSysError = ex.Message;

                    return Ok(mdlResponse);
                }

        
            }
        


            [HttpPost("SaveAirFareCode")]
            public IActionResult SaveAirFareCode([FromBody] MdlReqAirFareCode mdlReqAirFareCode)
            {
                try
                {
                    // &&& Get Data from Header
                    mdlReqAirFareCode.linLoginUserId = Convert.ToInt64(Request.Headers["linLoginUserId"]);
                    mdlReqAirFareCode.strLoginUserName = Request.Headers["strLoginUserName"];
                    mdlReqAirFareCode.strSysModuleName = Request.Headers["strSysModuleName"];
                    mdlReqAirFareCode.dtmCurrentDateTime = DateTime.Now;

                    // *** Authentication
                    if (mdlReqAirFareCode.linLoginUserId == 0) {
                        throw (new TaasAuthenticationException(this.insGlobalFunctions.FnGetExceptionResponseString("Login User Authentication Failed.", "AIRTICKET_CONTROLLER.CS#003")));
                    }

                    // *** ADD/UPDATE - User Permission Checking
                    string strAction = "ADD";
                    if (mdlReqAirFareCode.mdlAirFareCode.binAirFareCodeId > 0) 
                    {
                        strAction = "EDIT";
                    }
                    NpgsqlParameter[] lstSqlParameter = {
                        new NpgsqlParameter("linLoginUserId", NpgsqlDbType.Bigint) { Value = mdlReqAirFareCode.linLoginUserId, DataTypeName = "linLoginUserId"},
                        new NpgsqlParameter("vhrSysModuleName", NpgsqlDbType.Varchar, 250) { Value = mdlReqAirFareCode.strSysModuleName, DataTypeName = "vhrSysModuleName"},
                        new NpgsqlParameter("vhrAction", NpgsqlDbType.Varchar, 50) { Value = strAction, DataTypeName = "vhrAction"},
                    };
                    DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_check_user_permission(:linLoginUserId, :vhrSysModuleName, :vhrAction)",  lstSqlParameter);
                    if (objDataSet != null && Convert.ToInt16(objDataSet.Tables[0].Rows[0]["sin_sql_check_status"]) == -1)
                    {
                        throw (new TaasUserPermissionException(this.insGlobalFunctions.FnGetExceptionResponseString("You have no Permission to AirFareCode ADD/UPDATE.", "AIRTICKET_CONTROLLER.CS#004")));
                    }

                    // !!! Model Validation
                    if (!ModelState.IsValid)
                    {
                        string strMdlValidationErrors = String.Join("; ", ModelState.Values.SelectMany(objStateValue => objStateValue.Errors)
                                    .Select(objStateError => objStateError.ErrorMessage)
                                    .ToList());
                        throw (new TaasModelValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(strMdlValidationErrors, "AIRTICKET_CONTROLLER.CS#005")));
                    }

                    // @@@ Decrypt
                    
                    // ### Save
                    MdlResAirFareCode mdlResAirFareCode = this.insAirFareCode.FnInsertOrUpdateAirFareCode(mdlReqAirFareCode);

                    return Ok(mdlResAirFareCode);
                }
                
                catch (TaasAuthenticationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "AUTHENTICATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "Authentication Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasUserPermissionException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "USER_PERMISSION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode User Permission Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasModelValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "MODEL_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Model Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasLogicalException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "LOGICAL_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Logical Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasNoDataException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "NO_DATA_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode No Data Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Taas Error.";

                    return Ok(mdlResponse);
                }
                catch (Exception ex)
                {
                    MdlResponse mdlResponse = new MdlResponse();

                    mdlResponse.sinStatus = -1;
                    mdlResponse.strStatusCode = "ERROR";
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strErrorCode = "AIRTICKET_CONTROLLER.CS#001";
                    mdlResponse.strMessage = "AirFareCode Error.";
                    mdlResponse.strSysError = ex.Message;

                    return Ok(mdlResponse);
                }

        
            }
        


            [HttpPost("DeleteAirFareCode")]
            public IActionResult DeleteAirFareCode([FromBody] MdlReqBaseIntId mdlReqAirFareCodeBaseIntId)
            {
                try
                {
                    // &&& Get Data from Header
                    mdlReqAirFareCodeBaseIntId.linLoginUserId = Convert.ToInt64(Request.Headers["linLoginUserId"]);
                    mdlReqAirFareCodeBaseIntId.strLoginUserName = Request.Headers["strLoginUserName"];
                    mdlReqAirFareCodeBaseIntId.strSysModuleName = Request.Headers["strSysModuleName"];
                    mdlReqAirFareCodeBaseIntId.dtmCurrentDateTime = DateTime.Now;

                    // *** Authentication
                    if (mdlReqAirFareCodeBaseIntId.linLoginUserId == 0) {
                        throw (new TaasAuthenticationException(this.insGlobalFunctions.FnGetExceptionResponseString("Login User Authentication Failed.", "AIRTICKET_CONTROLLER.CS#006")));
                    }

                    // *** DELETE - User Permission Checking
                    string strAction = "DELETE";
                    NpgsqlParameter[] lstSqlParameter = {
                        new NpgsqlParameter("linLoginUserId", NpgsqlDbType.Bigint) { Value = mdlReqAirFareCodeBaseIntId.linLoginUserId, DataTypeName = "linLoginUserId"},
                        new NpgsqlParameter("vhrSysModuleName", NpgsqlDbType.Varchar, 250) { Value = mdlReqAirFareCodeBaseIntId.strSysModuleName, DataTypeName = "vhrSysModuleName"},
                        new NpgsqlParameter("vhrAction", NpgsqlDbType.Varchar, 50) { Value = strAction, DataTypeName = "vhrAction"},
                    };
                    DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_check_user_permission(:linLoginUserId, :vhrSysModuleName, :vhrAction)",  lstSqlParameter);
                    if (objDataSet != null && Convert.ToInt16(objDataSet.Tables[0].Rows[0]["sin_sql_check_status"]) == -1)
                    {
                        throw (new TaasUserPermissionException(this.insGlobalFunctions.FnGetExceptionResponseString("You have no Permission to AirFareCode DELETE.", "AIRTICKET_CONTROLLER.CS#007")));
                    }

                    // @@@ Decrypt
                    
                    // ### Delete
                    MdlResponse mdlResponse = this.insAirFareCode.FnDeleteAirFareCode(mdlReqAirFareCodeBaseIntId);

                    return Ok(mdlResponse);
                }
                
                catch (TaasAuthenticationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "AUTHENTICATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "Authentication Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasUserPermissionException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "USER_PERMISSION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode User Permission Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasModelValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "MODEL_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Model Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasLogicalException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "LOGICAL_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Logical Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasNoDataException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "NO_DATA_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode No Data Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Database System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AirFareCode Taas Error.";

                    return Ok(mdlResponse);
                }
                catch (Exception ex)
                {
                    MdlResponse mdlResponse = new MdlResponse();

                    mdlResponse.sinStatus = -1;
                    mdlResponse.strStatusCode = "ERROR";
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strErrorCode = "AIRTICKET_CONTROLLER.CS#001";
                    mdlResponse.strMessage = "AirFareCode Error.";
                    mdlResponse.strSysError = ex.Message;

                    return Ok(mdlResponse);
                }

        
            }
        

