???File Path
==========
***...\ClientApp\srcpp\src\travel\air-fare-code\air-fare-code.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlAirFareCode, MdlReqAirFareCode, MdlResAirFareCode, MdlResAirFareCodeInit, MdlResAirFareCodeList } from '../../../models/travel/airticket.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class AirFareCodeComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlAirFareCode: MdlAirFareCode = new MdlAirFareCode();
                public intActiveAirFareCodeIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlAirFareTypeBaseIntId: MdlBaseIntId[] = [];
			lstMdlAirlineMasterBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** AirFareCode List
                @ViewChild('#idDgAirFareCodeList') idDgAirFareCodeList!: DxDataGridComponent;
                public lstAllAirFareCode: MdlAirFareCode[] = [];
                public blnDgAirFareCodeShowFilterRow: boolean = false;
                public blnDgAirFareCodeHeaderFilter: boolean = false;
                public intActiveAirFareCodeListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'airFareCode';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "AIRFARECODE_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("AirFareCode");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetAirFareCodeInitializeData')
                    .then((mdlResAirFareCodeInit: MdlResAirFareCodeInit) => {
                        if (mdlResAirFareCodeInit.sinStatus == 1) {
                            this.lstMdlAirFareCode = mdlResAirFareCodeInit.lstMdlAirFareCode;

                            // ??? Remove not use items !!!
					this.lstMdlAirFareTypeBaseIntId = mdlResAirFareCodeInit.lstMdlAirFareTypeBaseIntId;
					this.lstMdlAirlineMasterBaseIntId = mdlResAirFareCodeInit.lstMdlAirlineMasterBaseIntId;

                        } else {
                            console.log(mdlResAirFareCodeInit.strMessage + " => " + mdlResAirFareCodeInit.strErrorCode + ' -> ' + mdlResAirFareCodeInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->AIRFARECODE.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnAirFareCodeListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnAirFareCodeListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlAirFareCode);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqAirFareCode: MdlReqAirFareCode = new MdlReqAirFareCode();
            mdlReqAirFareCode.mdlAirFareCode = JSON.parse(JSON.stringify(this.mdlAirFareCode));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveAirFareCode', mdlReqAirFareCode)
                .then((mdlResAirFareCode: MdlResAirFareCode) => {
                if (mdlResAirFareCode.sinStatus == 1) {
                    this.mdlAirFareCode = mdlResAirFareCode.mdlAirFareCode;
                    if (this.intActiveAirFareCodeIndex == -1) {
                    // New Item
                    this.intActiveAirFareCodeIndex = this.lstMdlAirFareCode.length;
                    this.lstMdlAirFareCode.push(JSON.parse(JSON.stringify(this.mdlAirFareCode)));
                    }
                    else {
                    // Update
                    this.lstMdlAirFareCode[this.intActiveAirFareCodeIndex] = JSON.parse(JSON.stringify(this.mdlAirFareCode));
                    //this.lstMdlAirFareCode.splice(this.intActiveAirFareCodeIndex, 1, this.mdlAirFareCode);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResAirFareCode.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResAirFareCode.strMessage, mdlResAirFareCode.strSysError);
                    console.log(mdlResAirFareCode);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->AIRFARECODE.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlAirFareCode.binAirFareCodeId == null || this.mdlAirFareCode.binAirFareCodeId < 1) {
                throw new Error('Select AirFareCode for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqAirFareCodeBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqAirFareCodeBaseIntId.mdlBaseIntId.binPkId = this.mdlAirFareCode.binAirFareCodeId;
            mdlReqAirFareCodeBaseIntId.mdlBaseIntId.binCustomValue = this.mdlAirFareCode.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteAirFareCode', mdlReqAirFareCodeBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlAirFareCode.splice(this.intActiveAirFareCodeIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->AIRFARECODE.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlAirFareCode = new MdlAirFareCode();
                    this.intActiveAirFareCodeIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlAirFareCode: MdlAirFareCode, intRowIndex: number) {
                this.mdlAirFareCode = JSON.parse(JSON.stringify(mdlAirFareCode));
                this.intActiveAirFareCodeIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlAirFareCode: MdlAirFareCode) {
                // ??? CHECK
                
                if (mdlAirFareCode.binAirFareTypeId == 0) {
                    throw new Error('Enter/Select Air Fare Type.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

