???File Path
==========
***...\Models\travel\AirticketModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@  AirFareCode  @@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlAirFareCode {

	public long binAirFareCodeId { get; set; } = 0;
	[Required()]
	[Display(Name = "Air Fare Type")]
	public long binAirFareTypeId { get; set; } = 0;
	
	public long? binAirlineMasterId { get; set; } = null;
	
	[DataType(DataType.Date)]
	[Display(Name = "Effective From")]
	public DateTime datEffectiveFrom { get; set; } = null;
	[DataType(DataType.Date)]
	[Display(Name = "Effective To")]
	public DateTime datEffectiveTo { get; set; } = null;
	public short sinEffectiveDateBasedOn { get; set; } = 0;
	
	[StringLength(50)]
	public string strAirFareCode { get; set; } = "";
	
}

public class MdlReqAirFareCode : MdlRequest {

	public MdlAirFareCode mdlAirFareCode { get; set; } = new MdlAirFareCode();
}

public class MdlResAirFareCode : MdlResponse {

	public MdlAirFareCode mdlAirFareCode { get; set; } = new MdlAirFareCode();
}

public class MdlResAirFareCodeList : MdlResponse {

	public List<MdlAirFareCode> lstMdlAirFareCode { get; set; } = new List<MdlAirFareCode>();
}

public class MdlResAirFareCodeInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlAirFareTypeBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlAirlineMasterBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlAirFareCode> lstMdlAirFareCode { get; set; } = new List<MdlAirFareCode>();
}

