???File Path
==========
***...\ClientApp\srcpp\src\travel\air-fare-type\air-fare-type.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlAirFareType, MdlReqAirFareType, MdlResAirFareType, MdlResAirFareTypeInit, MdlResAirFareTypeList } from '../../../models/travel/airticket.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class AirFareTypeComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlAirFareType: MdlAirFareType = new MdlAirFareType();
                public intActiveAirFareTypeIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** AirFareType List
                @ViewChild('#idDgAirFareTypeList') idDgAirFareTypeList!: DxDataGridComponent;
                public lstAllAirFareType: MdlAirFareType[] = [];
                public blnDgAirFareTypeShowFilterRow: boolean = false;
                public blnDgAirFareTypeHeaderFilter: boolean = false;
                public intActiveAirFareTypeListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'airFareType';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "AIRFARETYPE_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("AirFareType");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetAirFareTypeInitializeData')
                    .then((mdlResAirFareTypeInit: MdlResAirFareTypeInit) => {
                        if (mdlResAirFareTypeInit.sinStatus == 1) {
                            this.lstMdlAirFareType = mdlResAirFareTypeInit.lstMdlAirFareType;

                            // ??? Remove not use items !!!

                        } else {
                            console.log(mdlResAirFareTypeInit.strMessage + " => " + mdlResAirFareTypeInit.strErrorCode + ' -> ' + mdlResAirFareTypeInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->AIRFARETYPE.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnAirFareTypeListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnAirFareTypeListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlAirFareType);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqAirFareType: MdlReqAirFareType = new MdlReqAirFareType();
            mdlReqAirFareType.mdlAirFareType = JSON.parse(JSON.stringify(this.mdlAirFareType));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveAirFareType', mdlReqAirFareType)
                .then((mdlResAirFareType: MdlResAirFareType) => {
                if (mdlResAirFareType.sinStatus == 1) {
                    this.mdlAirFareType = mdlResAirFareType.mdlAirFareType;
                    if (this.intActiveAirFareTypeIndex == -1) {
                    // New Item
                    this.intActiveAirFareTypeIndex = this.lstMdlAirFareType.length;
                    this.lstMdlAirFareType.push(JSON.parse(JSON.stringify(this.mdlAirFareType)));
                    }
                    else {
                    // Update
                    this.lstMdlAirFareType[this.intActiveAirFareTypeIndex] = JSON.parse(JSON.stringify(this.mdlAirFareType));
                    //this.lstMdlAirFareType.splice(this.intActiveAirFareTypeIndex, 1, this.mdlAirFareType);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResAirFareType.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResAirFareType.strMessage, mdlResAirFareType.strSysError);
                    console.log(mdlResAirFareType);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->AIRFARETYPE.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlAirFareType.binAirFareTypeId == null || this.mdlAirFareType.binAirFareTypeId < 1) {
                throw new Error('Select AirFareType for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqAirFareTypeBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqAirFareTypeBaseIntId.mdlBaseIntId.binPkId = this.mdlAirFareType.binAirFareTypeId;
            mdlReqAirFareTypeBaseIntId.mdlBaseIntId.binCustomValue = this.mdlAirFareType.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteAirFareType', mdlReqAirFareTypeBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlAirFareType.splice(this.intActiveAirFareTypeIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->AIRFARETYPE.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlAirFareType = new MdlAirFareType();
                    this.intActiveAirFareTypeIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlAirFareType: MdlAirFareType, intRowIndex: number) {
                this.mdlAirFareType = JSON.parse(JSON.stringify(mdlAirFareType));
                this.intActiveAirFareTypeIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlAirFareType: MdlAirFareType) {
                // ??? CHECK
                
                if (mdlAirFareType.strAirFareTypeCode == "") {
                    throw new Error('Enter/Select Air Fare Type Code.');
                }
            
                if (mdlAirFareType.strAirFareType == "") {
                    throw new Error('Enter/Select Air Fare Type.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

